/*
myio.h
file handling functions
Prim Andras 2002
*/

#ifndef MYIO_H
#define MYIO_H

#define CR 0xd
#define LF 0xa

#include <ctype.h>
#include <stdio.h>
#define errorinfo(a) fprintf(stderr, a)
#ifdef DEBUG

#define debinfo(a) debugprintf(a,0)
#define debinfo2(a,b) printf(a,b)
#define debfuncbegin(a) debugprintf(a,1)
#define debfuncend(a) debugprintf(a,-1)

#else

#define debfuncbegin(a)
#define debfuncend(a)
#define debinfo(a)
#define debinfo2(a,b)

#endif


 /* skips lines with only blank characters and comments
    comment is a line which looks like <blanks>'#'<anything>'\n' */
void fskipNLsorcomments(FILE *fil);

 /* skips till the next newline */
void fskipline(FILE *fil);

 /* reads a string beginning with " character, ending with " or NEWLINE from
    'fil' returns the string in a newly allocated buffer
    returns NULL if EOF reached without reading */
char *freadstring(FILE *fil);

/* reads the first float number in 'fil' and puts into 'num'
 returns 0 on succes or not 0 when reaches EOF or any character in 'sep'
 before a number */
int freadfloat(FILE *fil, float *num, const char *sep);
void debugprintf(char *string, int indent);


#endif // first inclusion of this header
