/*
mystring.h
own string handling functions
Prim Andras 2002
*/

#ifndef MYSTRING_H
#define MYSTRING_H

  /* length of buffer in one link of the dynamic string chain
  */
#define DYNABUFLENGTH 64
#define FLOATLENGTH  32
#define FLOATESCAPE  '@'


typedef struct _dynalink {
  char buf[DYNABUFLENGTH];
  int length;
  struct _dynalink *next;
} dynalink;

typedef struct _dynastring {
  dynalink *first, *act;
    /* index where next character shall be inserted in the actual dynalink
    */
  int  i;
    /* sum length of the string
    */
  int length;
} dynastring;


void InitDS(dynastring *ds);
  /* copies first num characters of stringin into ds
  */
void AddStringToDS(dynastring *ds, char *stringin, int num);
  /* adds character ch to ds
  */
void AddCharToDS(dynastring *ds, char ch);
  /* adds float ch to ds
  */
void AddFloatToDS(dynastring *ds, float fl);

  /* returns the string in ds in a newly allocated buffer
  */
char *GetStringFromDS(dynastring *ds, int *length);
  /* frees memory allocated by the chain of ds, and initialises ds
  */
void FreeDS(dynastring *ds);

 /* returns the length of shortstr, if longstr begins with shortstr
 otherwise returns 0 */
int strbegin(char *longstr, char *shortstr);

#endif /* first inclusion of this header */
