#ifndef H_PASTUFF
#define H_PASTUFF

  // item number in a burst
#define STOREBURST 16
  // byte size of a burst
#define STACKBURST  256
#define max(a,b) ((a) > (b) ? (a) : (b))

typedef struct _stack
{
  int ptr, size;
  char *buf;
}stack;



void initstack(stack *st);
void freestack(stack *st);
  /* returns a pointer to the newly placed item
  this pointer shall be assumed proper only until the next push */
void *push(stack *st, void *this, int size);
void pop(stack *st, void *this, int size);
/* returns the current content of the stack in a newly allocated buffer */
void *getstack(stack *st, int *size);
void *getstackunsafe(stack *st, int *size);
#define zerostack(a) a.ptr = 0
#define getstacklength(a) ((a)->ptr)

typedef struct _store {
  int itemsize, burstsize;
  void **items;
  int burstnum, actualburst, index;
}store;

void initstore (store *st, int itemsize);
void initstore2 (store *st, int itemsize, int burstsize);
store *newstore (int itemsize);
store *newstore2 (int itemsize, int burstsize);
void freestaticstore (store *st);
void freestore (store *st);
void *addstoreitem (store *st, void *item);
void *getstoreitemaddress (store *st, int index);
void getstoreitem (store *st, int index, void *item);
void *getstore (store *st);
int getstoreitemnum(store *st);
#define getstoreitemnum(st) (st).actualburst * (st).burstsize + (st).index

#endif // first inclusion of this header
