# definition of leaf : one triangle per line
[-0.4 0.0 0.2  0.4 0.0 0.2  0.1 -0.2 0.6]
[-0.6 0.1 0.6  0.2 0.0 0.7  0.0 0.2 0.12]
[0.6 0.1 1.3  0.5 0.0 1.4  0.3 0.2 1.7]
[-0.6 0.4 1.7  0.2 0.4 1.8  0.2 0.4 1.13]
[0.0 0.4 1.3  0.5 0.4 1.4  0.3 0.5 1.7]
[-0.2 0.3 1.7  0.4 0.0 1.8  0.2 0.2 1.13]


# parameters
width  0.1 0.15  # initial radius of branches
length 0.5 0.8     # initial length of a branch segment
rot    0 40      # variance of rotation
sh     15 30     # pitch shift
wrate  1.1 1.2   # rate of width growth in one derivation
lrate  1 1.1     # rate of elongation in one derivation
rd     0 20      # bend of a branch
lp     0 1       # leaf position
la     0 360     # leaf angle

# axiom
"B(rd,0,width*wrate,width)A"

# B parameters:
# $1: bend of branch       $2: starting relative pitch
# $3: width at beginning
# rules
A : p(0.7) -> "\(70+rot)[B(rd,sh,width)A]
     \(70+rot)[B(rd,sh,width)A]
     \(70+rot)[B(rd,sh,width)A]
     \(70+rot)[B(rd,sh,width)A]"
A : p(0.4) -> "\(100+rot)[B(rd,sh,width)A]
     \(100+rot)[B(rd,sh,width)A]
     \(100+rot)[B(rd,sh,width)A]"
B : p(0.5) -> "!($3)+($2)F(length)
          +($1/2)F(length)L(lp,la)
          !($3*wrate+$3/2)+($1/2)F(length)L(lp,la)L(lp,la)
          +($1/2)F(length)L(lp,la)L(lp,la)
          !($3*wrate)+($1/2)F(length)L(lp,la)L(lp,la)
          +($1/2)F(length)L(lp,la)L(lp,la)"
B : p(0.5) -> "!($3)+($2)F(length)
          +($1)F(length)L(lp,la)
          !($3*wrate+$3/2)+($1)F(length)L(lp,la)L(lp,la)
          -($1)F(length)L(lp,la)L(lp,la)
          !($3*wrate)-($1)F(length)L(lp,la)L(lp,la)
          -($1)F(length)L(lp,la)L(lp,la)"
L : p(0.3) -> ""
F : * -> "F($1*lrate+0.1)"
! : * -> "!($1*wrate+0.1)"
