# definition of leaf : one triangle per line
[-0.4 0.0 0.2  0.4 0.0 0.2  0.1 -0.2 0.6]
[-0.6 0.1 0.6  0.2 0.0 0.7  0.0 0.2 0.12]
[0.6 0.1 1.3  0.5 0.0 1.4  0.3 0.2 1.7]
[-0.6 0.4 1.7  0.2 0.4 1.8  0.2 0.4 1.13]
[0.0 0.4 1.3  0.5 0.4 1.4  0.3 0.5 1.7]
[-0.2 0.3 1.7  0.4 0.0 1.8  0.2 0.2 1.13]


# parameters
width  0.1 0.15  # initial radius of branches
length 0.8 1     # initial length of a branch segment
rot    0 80      # variance of rotation
sh     10 20     # pitch shift
div    30 60     # divergence of B
wrate  1.1 1.2   # rate of width growth in one derivation
lrate  1.1 1.2   # rate of elongation in one derivation
rd     0 5       # bend of a middle branch
lp     0 1       # leaf position
la     0 360     # leaf angle

# axiom
"A"

# V parameters
# $1 width at beginning     $2 bend of branch
# rules
A : * -> "V(width,rd)[
           /(50+rot)[+(sh)V(width/4*3,sh)B]
           /(50+rot)[+(sh)V(width/4*3,sh)B]
           /(50+rot)[+(sh)V(width/4*3,sh)B]
           /(50+rot)[+(sh)V(width/4*3,sh)B]]A"
B : * -> "[+(sh)&(div)V(width/4*3,sh)B]
          [+(sh)^(div)V(width/4*3,sh)B]
          [+(sh)&(div-55/2)V(width/4*3,sh)B]"
V : * -> "!($1)F(length)L(lp,la)L(lp,la)
          !($1/wrate+$1/2)+($2)F(length)L(lp,la)
          !($1/wrate)+($2)F(length)L(lp,la)L(lp,la)"
L : p(0.3) -> ""
F : * -> "F(lrate*$1+0.1)"
! : * -> "!(wrate*$1+0.1)"
